
import Julian
JulianClass = Julian.Julian

def escape(name):
	import regsub
	return regsub.gsub('\([-.+?]\)', '\\\\\\1', name)

romans = ((1000, 'M'), (900, 'CM'), (500, 'D'), (400, 'CD'), (100, 'C'), (90, 'XC'), (50, 'L'), (40, 'XL'), (10, 'X'), (9, 'IX'), (5, 'V'), (4, 'IV'), (1, 'I'))
def rn(num):
	if num < 0:
		res = '-'
		num = -num
	else:
		res = ''
	for a in romans:
		res = res + a[1]*int((num/a[0]))
		num = num%a[0]
	return res

couples = {'CM':900, 'CD':400, 'XC':90, 'XL':40, 'IX':9, 'IV':4}
singles = {'M':1000, 'D':500, 'C':100, 'L':50, 'X':10, 'V':5, 'I':1}
def an(roman):
	import regex
	thous = regex.compile('M+')
	if roman and roman[0] == '-':
		neg = -1
		place = 1
	else:
		neg = 1
		place = 0
	if thous.match(roman, place) != -1:
		place = thous.regs[0][1]
		num = 1000L*(place - thous.regs[0][0])
	else:
		num = 0L
	while place < len(roman):
		if roman[place:place + 2] in couples.keys():
			num = num + couples[roman[place:place + 2]]
			place = place + 2
		else:
			num = num + singles[roman[place]]
			place = place + 1
	return neg*num

JulianClass.defaultFormat = '%c'
JulianClass.inputFormat = ''
JulianClass.dmonths = [
	('[0-1]?[0-9]', 1, 'string.atol(xfield.group(0))', '%b'),
	('[Jj][aA][nN][a-zA-Z]*', 1, '1', '%b'),
	('[Ff][eE][bB][a-zA-Z]*', 1, '2', '%b'),
	('[Mm][aA][rR][a-zA-Z]*', 1, '3', '%b'),
	('[Aa][pP][rR][a-zA-Z]*', 1, '4', '%b'),
	('[Mm][aA][yY][a-zA-Z]*', 1, '5', '%b'),
	('[Jj][uU][nN][a-zA-Z]*', 1, '6', '%b'),
	('[Jj][uU][lL][a-zA-Z]*', 1, '7', '%b'),
	('[Aa][uU][gG][a-zA-Z]*', 1, '8', '%b'),
	('[Ss][eE][pP][a-zA-Z]*', 1, '9', '%b'),
	('[Oo][cC][tT][a-zA-Z]*', 1, '10', '%b'),
	('[Nn][oO][vV][a-zA-Z]*', 1, '11', '%b'),
	('[Dd][eE][cC][a-zA-Z]*', 1, '12', '%b')
]
JulianClass.dwdays = [
	('[0-6]', 7, 'string.atol(xfield.group(0))', '%a'),
	('[Ss][uU][nN][a-zA-Z]*', 7, '0', '%a'),
	('[Mm][oO][nN][a-zA-Z]*', 7, '1', '%a'),
	('[Tt][uU][eE][a-zA-Z]*', 7, '2', '%a'),
	('[Ww][eE][dD][a-zA-Z]*', 7, '3', '%a'),
	('[Tt][hH][uU][a-zA-Z]*', 7, '4', '%a'),
	('[Ff][rR][iI][a-zA-Z]*', 7, '5', '%a'),
	('[Ss][aA][tT][a-zA-Z]*', 7, '6', '%a')
]
JulianClass.dzones = [
	('\\?\\?\\?\\?', 6, "'W-SU'", '%z'),
	('ADT', 6, "'Canada/Atlantic'", '%z'),
	('AST', 6, "'Canada/Atlantic'", '%z'),
	('BST', 6, "'GB-Eire'", '%z'),
	('CDT', 6, "'US/Central'", '%z'),
	('CST', 6, "'US/Central'", '%z'),
	('CWT', 6, "'US/Central'", '%z'),
	('EDT', 6, "'US/Eastern'", '%z'),
	('EET', 6, "'Turkey'", '%z'),
	('EET DST', 6, "'Turkey'", '%z'),
	('EST', 6, "'US/Eastern'", '%z'),
	('EWT', 6, "'US/Eastern'", '%z'),
	('GMT\\+0100', 6, "'GMT+1'", '%z'),
	('GMT\\+0200', 6, "'GMT+2'", '%z'),
	('GMT\\+0300', 6, "'GMT+3'", '%z'),
	('GMT\\+0400', 6, "'GMT+4'", '%z'),
	('GMT\\+0500', 6, "'GMT+5'", '%z'),
	('GMT\\+0600', 6, "'GMT+6'", '%z'),
	('GMT\\+0700', 6, "'GMT+7'", '%z'),
	('GMT\\+0800', 6, "'GMT+8'", '%z'),
	('GMT\\+0900', 6, "'GMT+9'", '%z'),
	('GMT\\+1000', 6, "'GMT+10'", '%z'),
	('GMT\\+1100', 6, "'GMT+11'", '%z'),
	('GMT\\+1200', 6, "'GMT+12'", '%z'),
	('GMT\\+1300', 6, "'GMT+13'", '%z'),
	('GMT\\-0100', 6, "'GMT-1'", '%z'),
	('GMT\\-0200', 6, "'GMT-2'", '%z'),
	('GMT\\-0300', 6, "'GMT-3'", '%z'),
	('GMT\\-0400', 6, "'GMT-4'", '%z'),
	('GMT\\-0500', 6, "'GMT-5'", '%z'),
	('GMT\\-0600', 6, "'GMT-6'", '%z'),
	('GMT\\-0700', 6, "'GMT-7'", '%z'),
	('GMT\\-0800', 6, "'GMT-8'", '%z'),
	('GMT\\-0900', 6, "'GMT-9'", '%z'),
	('GMT\\-1000', 6, "'GMT-10'", '%z'),
	('GMT\\-1100', 6, "'GMT-11'", '%z'),
	('GMT\\-1200', 6, "'GMT-12'", '%z'),
	('HDT', 6, "'US/Hawaii'", '%z'),
	('HST', 6, "'US/Hawaii'", '%z'),
	('HWT', 6, "'US/Hawaii'", '%z'),
	('JST', 6, "'Japan'", '%z'),
	('MDT', 6, "'US/Mountain'", '%z'),
	('MET', 6, "'Poland'", '%z'),
	('MET DST', 6, "'Poland'", '%z'),
	('MST', 6, "'US/Mountain'", '%z'),
	('MWT', 6, "'US/Mountain'", '%z'),
	('NDT', 6, "'Canada/Newfoundland'", '%z'),
	('NST', 6, "'Canada/Newfoundland'", '%z'),
	('NZDT', 6, "'NZ'", '%z'),
	('NZST', 6, "'NZ'", '%z'),
	('PDT', 6, "'US/Pacific'", '%z'),
	('PPET', 6, "'US/Pacific-New'", '%z'),
	('PST', 6, "'US/Pacific'", '%z'),
	('PWT', 6, "'US/Pacific'", '%z'),
	('SST', 6, "'Singapore'", '%z'),
	('WET', 6, "'Iceland'", '%z'),
	('WET DST', 6, "'WET'", '%z'),
	('WST', 6, "'Australia/West'", '%z'),
	('YDT', 6, "'US/Yukon'", '%z'),
	('YST', 6, "'US/Yukon'", '%z'),
	('YWT', 6, "'US/Yukon'", '%z')
]
for zn in JulianClass.Zone.zone_names():
	JulianClass.dzones.append((escape(zn), 6, `zn`, '%z'))
JulianClass.dampm = [('[AaPp][Mm]', 8, 'xfield.group(0)[0]', '%p')]
JulianClass.dyears = [('[-+]?[0-9]+', 0, 'string.atol(xfield.group(0))', '%Y')]
JulianClass.dsyears = [('[0-9]+', 0, 'xfield.group(0)', '%y')]
JulianClass.dromans = [('-?[MDCLXVI]+', 0, 'an(xfield.group(0))', '%R')]
JulianClass.ddays = [('[0-9]+', 2, 'string.atol(xfield.group(0))', '%d')]
JulianClass.djulian = [('[0-9]+', 10, 'string.atol(xfield.group(0))', '%J')]
JulianClass.dhours = [('[0-9]+', 3, 'string.atol(xfield.group(0))', '%H')]
JulianClass.dmins = [('[0-9]+', 4, 'string.atol(xfield.group(0))', '%M')]
JulianClass.dsecs = [('[0-9]+', 5, 'string.atol(xfield.group(0))', '%S')]
JulianClass.dtime = [('[0-9]+', 11, 'string.atol(xfield.group(0))', '%t')]
JulianClass.dzadj = [('[-+][0-9][0-9][0-9][0-9]', 9, 'xfield.group(0)', '%o')]
JulianClass.months = ['', 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec']
JulianClass.Months = ['', 'January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
JulianClass.weekdays = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat']
JulianClass.Weekdays = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday']
JulianClass.formatDict = {
	'a':('%s', 'self.weekdays[self.dayOfWeek()]', JulianClass.dwdays),
	'A':('%s', 'self.Weekdays[self.dayOfWeek()]', JulianClass.dwdays),
	'b':('%s', 'self.months[self.month]', JulianClass.dmonths),
	'B':('%s', 'self.Months[self.month]', JulianClass.dmonths),
	'c':('%s', '("%s %s %2d %2d:%02d:%02d %s %s" % (self.weekdays[self.dayOfWeek()], self.months[self.month], self.day, self.hour, self.minute, self.second, self.tz.info(self.time)[2], self.year))[:-1]', []),
	'd':('%d', 'self.day', JulianClass.ddays),
	'H':('%d', 'self.hour', JulianClass.dhours),
	'I':('%d', '(self.hour + 11)%12 + 1', JulianClass.dhours),
	'j':('%d', 'self.dayOfYear()', JulianClass.ddays),
	'J':('%s', 'self.julian', JulianClass.djulian),
	'm':('%d', 'self.month', JulianClass.dmonths),
	'M':('%02d', 'self.minute', JulianClass.dmins),
	'p':('%s', 'self.ap()', JulianClass.dampm),
	'S':('%02d', 'self.second', JulianClass.dsecs),
	't':('%s', 'self.time', JulianClass.dtime),
	'w':('%d', 'self.dayOfWeek()', JulianClass.dwdays),
	'x':('%s', '("%s %s %2d %s" % (self.weekdays[self.dayOfWeek()], self.months[self.month], self.day, self.year))[:-1]', []),
	'X':('%s', '"%2d:%02d:%02d %s" % (self.hour, self.minute, self.second, self.tz.info(self.time)[2])', []),
	'y':('%02d', 'self.year%100', JulianClass.dsyears),
	'Y':('%s', '("%s" % self.year)[:-1]', JulianClass.dyears),
	'R':('%s', 'rn(self.year)', JulianClass.dromans),
	'Z':('%s', 'self.tz.info(self.time)[2]', JulianClass.dzones),
	'z':('%s', 'self.zone', JulianClass.dzones),
	'o':('%s', 'self.tzAdjust()', JulianClass.dzadj)
}

def formattedOutput(self, format = ''):
	if not format:
		format = self.defaultFormat
	i = 0
	rstring = ''
	fill = []
	while i < len(format):
		if format[i] == '%':
			if format[i + 1] == '%':
				rstring = rstring + '%%'
				i = i + 2
			else:
				rstring = rstring + self.formatDict[format[i + 1]][0]
				fill.append(eval(self.formatDict[format[i + 1]][1]))
				i = i + 2
		else:
			rstring = rstring + format[i]
			i = i + 1
	return rstring % tuple(fill)

JulianClass.formattedOutput = formattedOutput

def ap(self):
	if self.hour < 12:
		return 'AM'
	else:
		return 'PM'

JulianClass.ap = ap

def tzAdjust(self):
	raw = self.tz.info(self.time)[0]
	if raw < 0:
		sign = -1
	else:
		sign = 1
	return '%+03d%02d' % (sign*(abs(raw)/3600), abs(raw)/60%60)
	
JulianClass.tzAdjust = tzAdjust

def _preTranslatedFormat(self, format):
	import regsub
	format = regsub.gsub('%c', '%a %b %d %H:%M:%S %Z %Y', format)
	format = regsub.gsub('%X', '%H:%M:%S %Z', format)
	format = regsub.gsub('%x', '%a %b %d %Y', format)
	return format

JulianClass._preTranslatedFormat = _preTranslatedFormat

def translatedFormat(self, format):
	import regsub
	format = self._preTranslatedFormat(format)
	format = regsub.gsub('%[dHIjJmMStyw]', '\([0-9]+\)', format)
	format = regsub.gsub('%[aAbBp]', '\([a-zA-Z]+\)', format)
	format = regsub.gsub('%[zZ]', '\([-+/0-9a-zA-Z?.]+\)', format)
	format = regsub.gsub('%o', '\([-+][0-9][0-9][0-9][0-9]\)', format)
	format = regsub.gsub('%Y', '\(-?[0-9]+\)', format)
	format = regsub.gsub('%R', '\(-?[MDCLXVI]+\)', format)
	format = regsub.gsub('[ ]+', '[ ]+', format)
	format = regsub.gsub(',', '[ ]*,[ ]*', format)
	format = regsub.gsub('%%', '%', format)
	return format

JulianClass.translatedFormat = translatedFormat

def formattedInput(self, instring, format = ''):
	import regex, regsub, string
	#          0       1     2  3  4  5   6     7     8     9    10    11
	#          y       m     d  h  M  s   z     w     p     a     J     t
	params = [None, None, None, 0, 0, 0, '', None, None, None, None, None]
	if not format:
		if self.inputFormat:
			format = self.inputFormat
		else:
			format = self.defaultFormat
	format = self._preTranslatedFormat(format)
	rformat = self.translatedFormat(format)
	xformat = regex.compile(rformat)
	if xformat.search(instring) == -1:
		raise ValueError, 'date %s did not fit format %s (translated to %s)' % (instring, format, rformat)
	i = 0
	group = 1
	while i < len(format):
		if format[i] == '%':
			key = format[i + 1]
			i = i + 2
			if key != '%':
				val = xformat.group(group)
				group = group + 1
				for s in self.formatDict[key][2]:
					xfield = regex.compile(s[0])
					if xfield.match(val) == len(val):
						params[s[1]] = eval(s[2])
						break
				else:
					raise ValueError, '%s not found for %s in %s' % (val, key, format)
		else:
			i = i + 1
	if params[10] != None:
		params[:3] = map(None, calendarDayForJulian(params[10]))
	if params[11] != None:
		params[:6] = [1970, 1, 1, 0, 0, params[11]]
		if not params[6]:
			params[6] = 'GMT'
		else:
			params[5] = params[5] + self.Zone.zone(params[6]).info(params[5])[0]
	if params[8] != None:
		if params[8] in 'pP':
			if params[3] != 12:
				params[3] = params[3] + 12
		elif params[3] == 12:
			params[3] = 0
	if params[9] != None:
		params[3] = params[3] - string.atol(params[9][:3])
		params[4] = params[4] - string.atol(params[9][0] + params[9][3:])
		params[6] = 'GMT'
	if None in params[:3]:
		a = now()
		if params[0] == None and params[1] == None and params[2] == None:
			params[0] = a.year
			params[1] = a.month
			params[2] = a.day
		else:
			if params[0] == None:
				params[0] = a.year
			if params[1] == None:
				params[1] = 1
			if params[2] == None:
				params[2] = 1
	if type(params[0]) == type(''):
		val = string.atol(params[0])
		if len(params[0]) < 3:
			cy = Julian.now().year
			cc = cy/100
			if cc*100 + val - cy > 50:
				params[0] = (cc - 1)*100 + val
			elif cc*100 + val - cy < -50:
				params[0] = (cc + 1)*100 + val
			else:
				params[0] = cc*100 + val
		else:
			params[0] = val
	apply(self.set, tuple(params[:7]))

JulianClass.formattedInput = formattedInput
JulianClass.pats = [
	('\([0-1]?[0-9]\)\([-/\.]\)\([0-3]?[0-9]\)\\2\([-+]?[0-9]+\)', 7, 'xfield.group(0)', '%m\\2%d\\2%y'),
	('\([0-3]?[0-9]\)\([-/\.]\)\([0-1]?[0-9]\)\\2\([-+]?[0-9]+\)', 7, 'xfield.group(0)', '%d\\2%m\\2%y'),
	('\([0-3]?[0-9]\)\([-/\.]\)\([a-zA-Z]+\)\\2\([-+]?[0-9]+\)\([-:\./]\)\([0-2]?[0-9]\):\([0-5]?[0-9]\):\([0-5]?[0-9]\)\([.:]?\)[0-9]*', 7, 'xfield.group(0)', '%d\\2%b\\2%y\\5%H:%M:%S\\9[0-9]*'),
	('\([0-3]?[0-9]\)\([-/\.]\)\([a-zA-Z]+\)\\2\([-+]?[0-9]+\)\([-:\./]\)\([0-2]?[0-9]\):\([0-5]?[0-9]\):\([0-5]?[0-9]\)\([.:]?\)[0-9]*[AaPp][Mm]', 7, 'xfield.group(0)', '%d\\2%b\\2%y\\5%H:%M:%S\\9[0-9]*%p'),
	('\([0-3]?[0-9]\)\([-/\.]\)\([a-zA-Z]+\)\\2\([-+]?[0-9]+\)', 7, 'xfield.group(0)', '%d\\2%b\\2%y'),
	('\([0-2]?[0-9]\):\([0-5]?[0-9]\):\([0-5]?[0-9]\)\([.:]?\)[0-9]*[AaPp][Mm]', 7, 'xfield.group(0)', '%H:%M:%S\\4[0-9]*%p'),
	('\([0-2]?[0-9]\):\([0-5]?[0-9]\):\([0-5]?[0-9]\)\([.:]?\)[0-9]*', 7, 'xfield.group(0)', '%H:%M:%S\\4[0-9]*'),
	('\([0-2]?[0-9]\):\([0-5]?[0-9]\)[AaPp][Mm]', 7, 'xfield.group(0)', '%H:%M%p'),
	('\([0-2]?[0-9]\):\([0-5]?[0-9]\)', 7, 'xfield.group(0)', '%H:%M'),
]
JulianClass.spare = [
	('[-+]?[0-9]+', 0, 'xfield.group(0)', '%n')
]
JulianClass.pstrings = [
	JulianClass.pats,
	JulianClass.dampm,
	JulianClass.dwdays[1:],
	JulianClass.dmonths[1:],
	JulianClass.dromans,
	JulianClass.dzadj,
	JulianClass.spare,
	JulianClass.dzones
]

def guessFormat(self, instring):
	import regsub, string, regex
	format = regsub.gsub('%', '%%', instring)
	rinstring = regsub.gsub(',', ' ', instring)
	parts = string.split(rinstring)
	for a in parts:
		didpart = 0
		for ps in self.pstrings:
			for s in ps:
				xfield = regex.compile(s[0])
				if xfield.match(a) == len(a):
					it = xfield.group(0)
					piece = regsub.sub(xfield, s[3], it)
					format = regsub.sub(escape(it), piece, format)
					didpart = 1
					break
			if didpart:
				break
	where = string.rfind(format, '%n')
	while where != -1:
		if regex.search('%[YyR]', format) == -1:
			format = format[:where] + regsub.sub('%n', '%y', format[where:])
		elif regex.search('%[dj]', format) == -1:
			format = format[:where] + regsub.sub('%n', '%d', format[where:])
		elif regex.search('%[mbB]', format) == -1:
			format = format[:where] + regsub.sub('%n', '%m', format[where:])
		else:
			raise ValueError, 'can\'t guess purpose of number (%%n) %s in %s' % (format, instring)
		where = string.rfind(format, '%n')
	return format

JulianClass.guessFormat = guessFormat

def parseInput(self, instring):
	self.formattedInput(instring, self.guessFormat(instring))

JulianClass.parseInput = parseInput

